import random
import time
import matplotlib.pyplot as plt
from statistics import mean

def recursif_max1(L):
	x = L[0]
	if len(L) == 1:
		# initialisation
		return x
	# cas général
	if x > recursif_max1(L[1:]):
		return x
	return recursif_max1(L[1:])

def recursif_max2(L):
	x = L[0]
	if len(L) == 1:
		return x # initialisation
	y = recursif_max2(L[1:])
	if x > y:
		return x
	return y

points = 10
repetition = 40

resultats1 = []
resultats2 = []
for i in range(10, points+10):
	print(i+10,end="\r")
	L = list(range(i))
	temps_calculs1 = []
	resultats1.append(temps_calculs1)
	temps_calculs2 = []
	resultats2.append(temps_calculs2)
	for _ in range(repetition):
		init_time = time.time_ns()
		_ = recursif_max1(L)
		stop_time = time.time_ns()
		temps_calculs1.append(stop_time - init_time)
		init_time = time.time_ns()
		_ = recursif_max2(L)
		stop_time = time.time_ns()
		temps_calculs2.append(stop_time - init_time)

plt.xlabel("Taille de la liste")
plt.title("Temps d'exécution des fonctions recursif_max1 et recursif_max2")
ax1 = plt.subplot(121)
ax1.plot(
	[(i+10) for i in range(points)],
	[mean(x)/10**3 for x in  resultats1],
	marker=".",
	label="recursif_max1"
	)
ax1.set_ylabel("Temps (en µs)")
ax1.set_xlabel("Taille de la liste")
plt.legend()
ax2 = plt.subplot(122)
ax2.plot(
	[(i+10) for i in range(points)],
	[mean(x)/10**3 for x in  resultats2],
	marker=".",
	label="recursif_max2",
	color = 'tab:red'
	)

ax2.set_ylabel("Temps (en µs)")
ax2.set_xlabel("Taille de la liste")
ax2.yaxis.set_ticks_position("right")
ax2.yaxis.set_label_position("right")
plt.legend()
plt.savefig("rec_maxs.png")
